#include <sys/stat.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <signal.h>
#include <time.h>

/*  Note: the I/O functions in Linux's asm/io.h only work right
 *  when compiled "-O".  Otherwise you get linker messages like:
 *      undefined reference to `__outb'
 */
#include <sys/io.h>
/* #include <asm/io.h>  needed for older include file setups */

int main(int argc, char *argv[])
{
	int i, port=0;
	unsigned int r;
	struct timespec req;

	if (argc < 1 || argc > 2) {
		printf("Usage: %s [ port ]\n", argv[0]);
		exit(1);
	}

	/* Find the port address, if any */
	if (argc == 2) port = strtol(argv[1],NULL,0);

	/* A little more setup */
	if (port) {
		printf("output to port 0x%x\n",port);
		if (ioperm(port,1,1)) { perror("ioperm"); exit(1); }
	}

	/* Do the work until SIGTERM */
	for (i=0;;i++) {
		/* You can play lots of games for show, like: */
		/* r=(r<<1)+(rand()&1); */
		r=i;
		if (port) {
			outb(r,port);
		} else {
			printf("0x%x\n", r);
		}
		/* Adjust speed here */
		req.tv_sec=1;
		req.tv_nsec=000000000;
		nanosleep(&req,NULL);
	}

	return 0;
}
